#include <sys/types.h>
#include <sys/mman.h>
#include <err.h>
#include <errno.h>
#include <fcntl.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/shm.h>


#define DAILYLOAD_IDX		100
#define TOTALLOAD_IDX		40

extern "C"
{


void initialize(unsigned char* di, unsigned char* coil, unsigned short* ir, unsigned short* hr, double* genr)
{
	int shmidInput;
	int shmidOutput;
	key_t key;

	genr[ 39 ] = 0;
	genr[ 40 ] = 97.6;
	genr[ 41 ] = 322;
	genr[ 42 ] = 500;
	genr[ 43 ] = 233.8;
	genr[ 44 ] = 522;
	genr[ 45 ] = 6.5;
	genr[ 46 ] = 8.53;
	genr[ 47 ] = 320;
	genr[ 48 ] = 329;
	genr[ 49 ] = 158;
	genr[ 50 ] = 680;
	genr[ 51 ] = 274;
	genr[ 52 ] = 247.5;
	genr[ 53 ] = 308.6;
	genr[ 54 ] = 224;
	genr[ 55 ] = 139;
	genr[ 56 ] = 281;
	genr[ 57 ] = 206;
	genr[ 58 ] = 283.5;
	genr[ 59 ] = 9.2;
	genr[ 60 ] = 1104;
}

void execStep(unsigned char* di, unsigned char* coil, unsigned short* ir, unsigned short* hr, double* genr)
{
	for ( int i = 0 ; i < 21 ; ++i ) {
		genr[TOTALLOAD_IDX+i] = genr[DAILYLOAD_IDX+i]/3;
	}
}

void getRequiredReadRegisters( unsigned char* di, unsigned char* coil, unsigned char* ir, unsigned char* hr, unsigned char* genr )
{
}

void getRequiredWriteRegisters( unsigned char* di, unsigned char* coil, unsigned char* ir, unsigned char* hr, unsigned char* genr )
{
}

} //extern "C"
